// DataView.cpp : implementation file
//

#include "stdafx.h"
#include "DataView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Ԫʼߴ
#define  UnitW    60
#define  UnitH    20

//ͷĳߴ
#define  HeaderW  65
#define  HeaderH  25

//ɫ
static const DWORD bkHeader = RGB(241,239,226); //ͷɫ.
static const DWORD bkGrid   = RGB(255,255,255); //񱳾ɫ.
static const DWORD lnHeader = RGB(128,128,128); //ͷɫ.
static const DWORD lnGrid   = RGB(192,192,192); //ɫ.

/////////////////////////////////////////////////////////////////////////////
// CDataView

IMPLEMENT_DYNCREATE(CDataView, CScrollView)

CDataView::CDataView():m_malloc(2000,8)
{
	int i,j;

	for(i=0;i<50;++i)
		for(j=0;j<50;++j)
			m_active[i][j] = 0;

	m_pen.CreatePen(PS_SOLID,1,lnGrid);

	LOGFONT lf;
    memset(&lf, 0, sizeof(LOGFONT));
    lf.lfHeight = 16;
    strcpy(lf.lfFaceName, "");
 
	m_font.CreateFontIndirect(&lf);
}

CDataView::~CDataView()
{
	int i,j;

	m_font.DeleteObject();
	
	for(i=0;i<50;++i)
		for(j=0;j<50;++j)
			if(m_active[i][j])
			  m_malloc.free(m_active[i][j]);
}

//Ϊؼʹʱ,ֱӵͼ.ͬʱָϢͻص.
BOOL CDataView::Create(RECT &rc,CWnd *pParent,int row,int col,CallBackFunc pFunc,void *p)
{
	BOOL re = CScrollView::Create(NULL,NULL,WS_CHILD,rc,pParent,1008);

	int i;

    for(i=0;i<row;i++)
	{ 
		m_row_h.push_back(UnitH);
	}

	for(i=0;i<col;i++)
	{
	   m_col_w.push_back(UnitW);
	}

	m_pFunc = pFunc;
    m_pVoid = p;

	return re;
}

void NeedData(int x,int y,char *buf,void *p)//ݻص
{
	itoa(x+y+2,buf,10);
}

//Ϊͼʹʱ,ڴñϢͻص.
//Ϊؼʹʱ,ӦɾͶӦϢӳ.
int CDataView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;

	int row = 80000;
	int col = 80000;

	int i;

    for(i=0;i<row;i++)
	{ 
		m_row_h.push_back(UnitH);
	}

	for(i=0;i<col;i++)
	{
	   m_col_w.push_back(UnitW);
	}

	m_pFunc = NeedData;
    m_pVoid = 0;
	
	return 0;
}

void CDataView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	DWORD rows = m_row_h.size();
	DWORD cols = m_col_w.size();
	DWORD i,j,w=HeaderW,h=HeaderH;

	for(i=0;i<cols;++i)	w += m_col_w[i];

	for(j=0;j<rows;++j)	h += m_row_h[j];

	SIZE sizeTotal;
	sizeTotal.cx = w;
	sizeTotal.cy = h;

	SIZE sizePage;
	sizePage.cx = 0;
	sizePage.cy = 0;
	
	SIZE sizeLine;
	sizeLine.cx = UnitW;
	sizeLine.cy = UnitH;

	SetScrollSizes(MM_TEXT,sizeTotal,sizePage,sizeLine);
}

void CDataView::PostNcDestroy()
{
	//Ϊؼʹʱ,Ӧε,Ϊ
	//ȷɾ,ӦϢɾ.
	CScrollView::PostNcDestroy();
}

BEGIN_MESSAGE_MAP(CDataView, CScrollView)
	//{{AFX_MSG_MAP(CDataView)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDataView drawing
void CDataView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	OnDraw(&dc);
}

BOOL CDataView::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}

void CDataView::OnDraw(CDC* pDC)
{
	CDC     dcMem;
    CBitmap bmp;

	int w = m_rcRegion.right-m_rcRegion.left;
	int h = m_rcRegion.bottom-m_rcRegion.top;

    if(bmp.CreateCompatibleBitmap(pDC,w,h)&&dcMem.CreateCompatibleDC(pDC))
	{
		CPoint pt = GetDeviceScrollPosition();

		dcMem.SelectObject(&bmp);
		dcMem.FillSolidRect(0,0,w,h,bkGrid);
		
		DrawData(&dcMem,pt);
        DrawHeader(&dcMem,pt);

		pDC->BitBlt(0,0,w,h,&dcMem,0,0,SRCCOPY);
	}
}

void CDataView::DrawHeader(CDC* pDC,const CPoint &ptScroll)//ͷ
{
	int x1 = m_rcRowCol.left   +1;//кŴ1ʼ.
	int x2 = m_rcRowCol.right  +1;
	int y1 = m_rcRowCol.top    +1;//кŴ1ʼ.
	int y2 = m_rcRowCol.bottom +1;

    pDC->FillSolidRect(0,0,m_rcRegion.right, HeaderH,bkHeader);
	pDC->FillSolidRect(0,0,HeaderW,m_rcRegion.bottom,bkHeader);

	int x0 = (x1-1)*UnitW-ptScroll.x+HeaderW;
	int y0 = (y1-1)*UnitH-ptScroll.y+HeaderH;

	int i,j,x,y;
    CPen  pen;
	pen.CreatePen(PS_SOLID,1,lnHeader);

	CPen  *oldpen  = pDC->SelectObject(&pen);

	char  num[20];

	y = y0;
	for(i=y1;i<=y2;++i)//
	{
		pDC->MoveTo(0,       y);
		pDC->LineTo(HeaderW, y);

		itoa(i,num,10);
		pDC->TextOut(8,y+2,num);

		y += UnitH;
	}
	pDC->MoveTo(0,       y);
	pDC->LineTo(HeaderW, y);

	x = x0;
	for(j=x1;j<=x2;++j)//
	{
		pDC->MoveTo(x,      0);
		pDC->LineTo(x,HeaderH);

		itoa(j,num,10);
		pDC->TextOut(x+3,4,num);

		x += UnitW;
	}
	pDC->MoveTo(x,      0);
	pDC->LineTo(x,HeaderH);

    pDC->FillSolidRect(0,0,HeaderW, HeaderH,bkHeader);

	pDC->MoveTo(HeaderW-1,       HeaderH-1);
	pDC->LineTo(m_rcRegion.right,HeaderH-1);

	pDC->MoveTo(HeaderW-1,HeaderH-1);
	pDC->LineTo(HeaderW-1,m_rcRegion.bottom);
  
	pDC->SelectObject(oldpen);
}

void CDataView::DrawData(CDC* pDC,const CPoint &ptScroll)//ݲ
{
	int x1 = m_rcRowCol.left   ;
	int x2 = m_rcRowCol.right  ;
	int y1 = m_rcRowCol.top    ;
	int y2 = m_rcRowCol.bottom ;
	
	int x0 = x1*UnitW-ptScroll.x+HeaderW;
	int y0 = y1*UnitH-ptScroll.y+HeaderH;

	int x=x0,y=y0;

	int i,j;
	char *txt;

	CPen  *oldpen  = pDC->SelectObject(&m_pen);
	CFont *oldfont = pDC->SelectObject(&m_font);

	x = (x2+1)*UnitW+HeaderW;
	y = y0;
	for(i=y1;i<=y2+1;++i)//
	{
		pDC->MoveTo(x0,y);
		pDC->LineTo(x, y);
		y += UnitH;
	}

	x = x0;
	y = (y2+1)*UnitH+HeaderH;
	for(j=x1;j<=x2+1;++j)//
	{
		pDC->MoveTo(x,y0);
		pDC->LineTo(x, y);
		x += UnitW;
	}

	x=x0;
	y=y0;
	for(i=y1;i<=y2;++i)
	{
		x = x0;
		for(j=x1;j<=x2;++j)
		{
			txt = m_active[i-y1][j-x1];

			pDC->TextOut(x+5,y+3,txt);

			x += UnitW;
		}

		y += UnitH;
	}

	pDC->SelectObject(oldfont);
	pDC->SelectObject(oldpen);
}
/////////////////////////////////////////////////////////////////////////////

//Ϊ˹Χɳ32768,дĺ.
BOOL CDataView::OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll) 
{
	if(nScrollCode == MAKEWORD(-1,SB_THUMBPOSITION) ||
	   nScrollCode == MAKEWORD(-1,SB_THUMBTRACK)    ||//WM_VSCROLLTHUMB pos.
	   nScrollCode == MAKEWORD(SB_THUMBPOSITION,-1) ||
       nScrollCode == MAKEWORD(SB_THUMBTRACK,   -1))  //WM_HSCROLLTHUMB pos.
	{
		SCROLLINFO si;

		ZeroMemory(&si, sizeof(SCROLLINFO));
		si.cbSize = sizeof(SCROLLINFO);
		si.fMask = SIF_TRACKPOS;
 
		int srcollbar = LOBYTE(nScrollCode)==BYTE(-1) ? SB_VERT : SB_HORZ;

		if(::GetScrollInfo(m_hWnd, srcollbar, &si))
		{
			nPos = si.nTrackPos; //ԭnPosֵܳ16λ.¼
		}
	}

	return  CScrollView::OnScroll(nScrollCode, nPos, bDoScroll);
}

BOOL CDataView::OnScrollBy(CSize sizeScroll, BOOL bDoScroll)
{
	int xOrig, x;
	int yOrig, y;

	// don't scroll if there is no valid scroll range (ie. no scroll bar)
	CScrollBar* pBar;
	DWORD dwStyle = GetStyle();
	pBar = GetScrollBarCtrl(SB_VERT);
	if ((pBar != NULL && !pBar->IsWindowEnabled()) ||
		(pBar == NULL && !(dwStyle & WS_VSCROLL)))
	{
		// vertical scroll bar not enabled
		sizeScroll.cy = 0;
	}
	pBar = GetScrollBarCtrl(SB_HORZ);
	if ((pBar != NULL && !pBar->IsWindowEnabled()) ||
		(pBar == NULL && !(dwStyle & WS_HSCROLL)))
	{
		// horizontal scroll bar not enabled
		sizeScroll.cx = 0;
	}

	// adjust current x position
	xOrig = x = GetScrollPos(SB_HORZ);
	int xMax = GetScrollLimit(SB_HORZ);
	x += sizeScroll.cx;
	if (x < 0)
		x = 0;
	else if (x > xMax)
		x = xMax;

	// adjust current y position
	yOrig = y = GetScrollPos(SB_VERT);
	int yMax = GetScrollLimit(SB_VERT);
	y += sizeScroll.cy;
	if (y < 0)
		y = 0;
	else if (y > yMax)
		y = yMax;

	// did anything change?
	if (x == xOrig && y == yOrig)
		return FALSE;

	if (bDoScroll)
	{
		// do scroll and update scroll positions
		//ScrollWindow(-(x-xOrig), -(y-yOrig));

		if (x != xOrig)
			SetScrollPos(SB_HORZ, x);

		if (y != yOrig)
			SetScrollPos(SB_VERT, y);
	}

	{
		RECT rc;

		CPoint pt(GetScrollPos(SB_HORZ), GetScrollPos(SB_VERT));
		
		ASSERT(pt.x >= 0 && pt.y >= 0);

		GetClientRect(&rc);
		::OffsetRect(&rc,pt.x,pt.y);//ҪʾĴ.

		if(::EqualRect(&rc,&m_rcRegion))
		{
			return TRUE;
		}

        m_rcRegion = rc;

		UpdataActiveData();

        Invalidate();
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////

void CDataView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);

	CPoint pt(GetScrollPos(SB_HORZ), GetScrollPos(SB_VERT));
		
	ASSERT(pt.x >= 0 && pt.y >= 0);	

	GetClientRect(&m_rcRegion);
	::OffsetRect(&m_rcRegion,pt.x,pt.y);//ҪʾĴ.

	UpdataActiveData();
}

char *CDataView::GetData(int row,int col)//ȡ.
{
	char txt[256],*temp;
	int  len;

    m_pFunc(col,row,txt,m_pVoid);

    len = strlen(txt)+1;

    temp = (char *)m_malloc.malloc(len);

    strcpy(temp,txt);

	return temp;
}

void  CDataView::UpdataActiveData()
{
	RECT  rcNew;

	RegionToRowCol(m_rcRegion,rcNew);//Ҫʾ.

	if(::EqualRect(&m_rcRowCol,&rcNew))
	{
		return;
	}

	//ԭ m_rcRowCol ,Ҫ rcNew .
    RECT  rcInersect;
	::IntersectRect(&rcInersect,&m_rcRowCol,&rcNew);

	if(::IsRectEmpty(&rcInersect))//ûн,ȫȡ.
	{
		int x0,y0,w,h,i,j;

		x0 = m_rcRowCol.left;
		y0 = m_rcRowCol.top;
		w  = m_rcRowCol.right  - x0;
		h  = m_rcRowCol.bottom - y0;

		for(i=0; i<=h; ++i)
			for(j=0; j<=w; ++j)//ͷԭ.
			{
				m_malloc.free(m_active[i][j]);

				m_active[i][j] = 0;
			}

		x0 = rcNew.left;
		y0 = rcNew.top;
		w  = rcNew.right  - x0;
		h  = rcNew.bottom - y0;

		for(i=0; i<=h; ++i)
			for(j=0; j<=w; ++j)//ȡ.
			{
				m_active[i][j] = GetData(i+y0,j+x0);
			}

	   m_rcRowCol = rcNew;

       return ;
	}

	::OffsetRect(&rcInersect,-m_rcRowCol.left,-m_rcRowCol.top);

	char * temp[50][50];
	memset(temp,0,50*50*sizeof(char *));

	int i,j,x1,y1,x2,y2;

	x1 = rcInersect.left;
	x2 = rcInersect.right;
	y1 = rcInersect.top;
	y2 = rcInersect.bottom;

    for(i=y1; i<=y2; ++i)
		for(j=x1; j<=x2; ++j) //ԭȻҪʾĸƵtemp.
		{
			temp[i-y1][j-x1] = m_active[i][j];
		}

	for(i=0;i<50;++i)
		for(j=0;j<50;++j)//ͷԭвҪĲ.
		{
			if( (j<x1 || j>x2 || i<y1 || i>y2) //ཻ֮.
				&& m_active[i][j])
			{
				m_malloc.free(m_active[i][j]);
			}

			m_active[i][j] = 0;
		}

	::IntersectRect(&rcInersect,&m_rcRowCol,&rcNew);
	::OffsetRect(&rcInersect,-rcNew.left,-rcNew.top);
	x1 = rcInersect.left;
	x2 = rcInersect.right;
	y1 = rcInersect.top;
	y2 = rcInersect.bottom;

    int x0,y0,w,h;

	x0 = rcNew.left;
	y0 = rcNew.top;
	w  = rcNew.right  - x0;
    h  = rcNew.bottom - y0;

	for(i=0; i<=h; ++i)
		for(j=0; j<=w; ++j)//ȡ.
		{	
			if(j>=x1&&j<=x2&&i>=y1&&i<=y2)//Ѿи. 
            {
				m_active[i][j] = temp[i-y1][j-x1];
			}
			else
			{
				m_active[i][j] =  GetData(i+y0,j+x0);
			}
		}

   m_rcRowCol = rcNew;
}

//㴰Ӧк
void  CDataView::RegionToRowCol(const RECT &rcRegion,RECT &rcRowCol)
{
	DWORD rows = m_row_h.size();
	DWORD cols = m_col_w.size();
	DWORD i,j,w=0,h=0;

	int   x1=-1,y1=-1,x2,y2;

	for(i=0;i<cols;++i)
	{
		w += m_col_w[i];

		if(x1==-1 && w>rcRegion.left)
		{
			x1 = i;
		}
		
		if(w>rcRegion.right)
		{
			x2 = i;
			break;
		}
	}

	if(x1<0)       x1 = 0;
	if(x2>cols-1)  x2 = cols-1;


	for(j=0;j<rows;++j)
	{
		h += m_row_h[j];

		if(y1==-1 && h>rcRegion.top)
		{
			y1 = j;
		}
		
		if(h>rcRegion.bottom)
		{
			y2 = j;
			break;
		}
	}

	if(y1<0)       y1 = 0;
	if(y2>rows-1)  y2 = rows-1;

	rcRowCol.left   = x1;
	rcRowCol.right  = x2;
	rcRowCol.top    = y1;
	rcRowCol.bottom = y2;
}


